$opposing-sides: (
  "bottom": "top",
  "top": "bottom",
  "left": "right",
  "right": "left",
);

.container {
  position: relative;

  &.dotted {
    border-bottom: 1px dotted;
    text-decoration: none;
    cursor: help;
  }

  > .tooltip {
    --font-weight: 400;
    --color: var(--tooltip-color);
    --background: var(--tooltip-background-color);
    --typography-spacing-vertical: calc(var(--spacing) * 0.3);
    display: block;
    position: absolute;
    padding: 0.25rem 0.5rem;
    border-radius: var(--border-radius);
    background: var(--background);
    border: 1px solid var(--background);
    color: var(--color);
    font-style: normal;
    font-weight: var(--font-weight);
    font-size: 0.875rem;
    text-decoration: none;
    white-space: pre;
    pointer-events: none;
    transition: 0.2s opacity;
    z-index: var(--tooltip-z-index, 99);
    // Caret
    > .caret {
      padding: 0;
      &[data-side="bottom"] {
        border-top: 0.3rem solid;
        border-right: 0.3rem solid transparent;
        border-left: 0.3rem solid transparent;
      }
      &[data-side="top"] {
        border-bottom: 0.3rem solid;
        border-right: 0.3rem solid transparent;
        border-left: 0.3rem solid transparent;
      }
      &[data-side="right"] {
        border-left: 0.3rem solid;
        border-top: 0.3rem solid transparent;
        border-bottom: 0.3rem solid transparent;
      }
      &[data-side="left"] {
        border-right: 0.3rem solid;
        border-top: 0.3rem solid transparent;
        border-bottom: 0.3rem solid transparent;
      }
      border-radius: 0;
      background-color: transparent;
      content: "";
      color: var(--tooltip-background-color);
      position: absolute;
      // left: calc(50% - 0.3rem);
      // bottom: calc(-1 * 0.3rem);
    }
  }

  &.controlled:not(.active) > .tooltip {
    opacity: 0;
  }

  &:not(.controlled) > .tooltip {
    bottom: 100%;
    left: 50%;
    transform: translate(-50%, -0.25rem);
    opacity: 0;
  }

  // Animations, excluding touch devices
  @media (hover: hover) and (pointer: fine) {
    @each $side in left, right, bottom, top {
      &:where(.active, :focus, :hover) > .tooltip {
        --tooltip-z-index: 1000;
        &[data-placement="#{$side}"] {
          animation-duration: 0.2s;
          animation-name: slide-#{$side};
          > .caret {
            animation-duration: 0.2s;
            animation-name: slide-#{map-get($opposing-sides, $side)};
          }
        }
      }
    }
  }
}

.tooltipContent > p:last-child {
  margin: 0;
}

@keyframes slide-left {
  from {
    transform: translateX(0.75rem);
    opacity: 0;
  }
  to {
    transform: translateX(0);
    opacity: 1;
  }
}

@keyframes slide-right {
  from {
    transform: translateX(-0.75rem);
    opacity: 0;
  }
  to {
    transform: translateX(0);
    opacity: 1;
  }
}

@keyframes slide-bottom {
  from {
    transform: translateY(-0.75rem);
    opacity: 0;
  }
  to {
    transform: translateY(0);
    opacity: 1;
  }
}

@keyframes slide-top {
  from {
    transform: translateY(0.75rem);
    opacity: 0;
  }
  to {
    transform: translateY(0);
    opacity: 1;
  }
}

#layerWrapper {
  position: fixed;
  top: var(--spacing);
  left: var(--spacing);
  width: calc(100vw - 2 * var(--spacing));
  height: calc(100vh - 2 * var(--spacing));
  cursor: none;
  pointer-events: none;
}

#layer {
  position: relative;
  width: 100%;
  height: 100%;
}
